package com.platform.entities;

/**
 * 数据信息实体类
 * 
 * @author wuming
 * 
 */
public class DataInfoEntity {
	private int id;
	private String regionalismCode; // 行政区划编码
	private String cityName; // 市
	private String districtName; // 区县
	private int systemCode; // 系统编码
	private String systemName; // 系统名称
	private String dataType; // 数据类型：财政\社保\...
	private int dataVersion; // 数据版本
	private String submittedBatch; // 上报批次
	private String dataPath; // 数据路径
	private String collectingTime; // 采集时间
	private String collectorContacts; // 采集人的联系
	private String charset; // 数据的字符编码
	private String collectorName; // 采集人姓名
	private String year; // 数据年度

	public DataInfoEntity() {
	}

	public DataInfoEntity(int id, String regionalismCode, String cityName,
			String districtName, int systemCode, String systemName,
			String dataType, int dataVersion, String submittedBatch,
			String dataPath, String collectingTime, String collectorContacts,
			String charset, String collectorName, String year) {
		super();
		this.id = id;
		this.regionalismCode = regionalismCode;
		this.cityName = cityName;
		this.districtName = districtName;
		this.systemCode = systemCode;
		this.systemName = systemName;
		this.dataType = dataType;
		this.dataVersion = dataVersion;
		this.submittedBatch = submittedBatch;
		this.dataPath = dataPath;
		this.collectingTime = collectingTime;
		this.collectorContacts = collectorContacts;
		this.charset = charset;
		this.collectorName = collectorName;
		this.year = year;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getRegionalismCode() {
		return regionalismCode;
	}

	public void setRegionalismCode(String regionalismCode) {
		this.regionalismCode = regionalismCode;
	}

	public String getCityName() {
		return cityName;
	}

	public void setCityName(String cityName) {
		this.cityName = cityName;
	}

	public String getDistrictName() {
		return districtName;
	}

	public void setDistrictName(String districtName) {
		this.districtName = districtName;
	}

	public int getSystemCode() {
		return systemCode;
	}

	public void setSystemCode(int systemCode) {
		this.systemCode = systemCode;
	}

	public String getSystemName() {
		return systemName;
	}

	public void setSystemName(String systemName) {
		this.systemName = systemName;
	}

	public String getDataType() {
		return dataType;
	}

	public void setDataType(String dataType) {
		this.dataType = dataType;
	}

	public int getDataVersion() {
		return dataVersion;
	}

	public void setDataVersion(int dataVersion) {
		this.dataVersion = dataVersion;
	}

	public String getSubmittedBatch() {
		return submittedBatch;
	}

	public void setSubmittedBatch(String submittedBatch) {
		this.submittedBatch = submittedBatch;
	}

	public String getDataPath() {
		return dataPath;
	}

	public void setDataPath(String dataPath) {
		this.dataPath = dataPath;
	}

	public String getCollectingTime() {
		return collectingTime;
	}

	public void setCollectingTime(String collectingTime) {
		this.collectingTime = collectingTime;
	}

	public String getCollectorContacts() {
		return collectorContacts;
	}

	public void setCollectorContacts(String collectorContacts) {
		this.collectorContacts = collectorContacts;
	}

	public String getCharset() {
		return charset;
	}

	public void setCharset(String charset) {
		this.charset = charset;
	}

	public String getCollectorName() {
		return collectorName;
	}

	public void setCollectorName(String collectorName) {
		this.collectorName = collectorName;
	}

	public String getYear() {
		return year;
	}

	public void setYear(String year) {
		this.year = year;
	}

	@Override
	public String toString() {
		return "id=" + this.id + " ,regionalismCode=" + this.regionalismCode
				+ " ,cityName=" + this.cityName + " ,districtName="
				+ this.districtName + " ,systemCode=" + this.systemCode
				+ " ,systemName" + this.systemName + " ,dataType="
				+ this.dataType + " ,dataVersion=" + this.dataVersion
				+ " ,submittedBatch=" + this.submittedBatch + " ,dataPath="
				+ this.dataPath + " ,collectingTime=" + this.collectingTime
				+ " ,collectorContacts=" + this.collectorContacts
				+ " ,charset=" + this.charset + " ,collectorName="
				+ this.collectorName + " ,year=" + this.year + "";
	}

}
